<?php

define('THIS_SCRIPT', 'vbtwitter_authorize');
define('CSRF_PROTECTION', true);

$phrasegroups = array();
$specialtemplates = array();
$globaltemplates = array();
$actiontemplates = array();

require_once('./global.php');
require_once(DIR . '/includes/class_twitterOAuth.php');

$userdata =& datamanager_init('User', $vbulletin, ERRTYPE_STANDARD);
$userdata->set_existing($vbulletin->userinfo);

if($_REQUEST['oauth_token'] == '')
{
	$twitter = new TwitterOAuth($vbulletin->options['twitter_key_pub'], $vbulletin->options['twitter_key_sec']);

	$tokens = $twitter->getRequestToken();
	$token = $tokens['oauth_token'];
	$twitter->getAuthorizeURL($token);
	
	// Update & set database!
	require_once(DIR . '/includes/functions_misc.php');
	
	$userdata->set('oauth_token', $tokens['oauth_token']);
	$userdata->set('oauth_token_secret', $tokens['oauth_token_secret']);
	$userdata->save();
	
	// redirect to authorize URL.
	header('Location: ' . $twitter->getAuthorizeURL($token));
	exit;
}

if($_GET['oauth_token'] != '')
{
	$twitter = new TwitterOAuth($vbulletin->options['twitter_key_pub'], $vbulletin->options['twitter_key_sec'], $vbulletin->userinfo['oauth_token'], $vbulletin->userinfo['oauth_token_secret']);
	$tokens = $twitter->getAccessToken();
	
	$userdata->set('oauth_token', $tokens['oauth_token']);
	$userdata->set('oauth_token_secret', $tokens['oauth_token_secret']);
	$userdata->save();

	$twitter->OAuthRequest('https://twitter.com/statuses/update.xml', array('status' => 'I have successfully set up my account to work with vBTwitter at one of the sites I visit! (This message means it was successful!)'), 'POST');
	header('Location: ' . $vbulletin->options['bburl'] . '/index.php');
	exit;
}

?>